=== src/TKQADraw/CMakeLists.txt ===
project(TKQADraw)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
