=== src/TKXDE/CMakeLists.txt ===
project(TKXDE)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
