=== src/TKXDECascade/CMakeLists.txt ===
project(TKXDECascade)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
